﻿#ifndef __DHWRDEF_H__
#define __DHWRDEF_H__

/*!
 *  @date  2009/08/13
 *  @file  dhwr_define.h
 *  @author  shchoi
 *
 *  Copyright (c) 2016 by SELVAS AI Inc. All rights reserved.
 */

#ifdef  __cplusplus
#define EXTERN    extern "C"
#else
#define EXTERN    extern
#endif
#if defined(DHWR_EXPORT)
#if defined(_WIN32)
#define DHWR_API  EXTERN __declspec(dllexport)
#else
#define DHWR_API EXTERN __attribute__((visibility("default")))
#endif
#elif defined(DHWR_IMPORT)
#if defined(_WIN32)
#define DHWR_API  EXTERN __declspec(dllimport)
#endif
#else
#define DHWR_API  EXTERN
#endif

#ifndef BIT_FLAG
#define BIT_FLAG( n ) ( 1 << ( n ) )
#endif

typedef enum
{
  DHWR_LOG_LEVEL = 0,
  DHWR_LOG_CALLBACK = 1,
  DHWR_WRITE_INK = 2,
	DHWR_LANG_MODEL = 3
} DHWR_PARAMTYPE;

/*!
*  @brief DHWR Candidate Rect
*/

typedef struct tagDHWRRect
{
  unsigned short left;
  unsigned short top;
  unsigned short right;
  unsigned short bottom;
} DHWRRect;

/*!
*  @brief Log level
*/
typedef enum tagDHWRLogLevel
{
  LEVEL_NONE = 0,
  LEVEL_ERROR,
  LEVEL_WARN,
  LEVEL_INFO,
  LEVEL_DEBUG,

  SIZE_LEVEL
} DHWRLogLevel;

/*!
*  @brief Log callback
*  @see DHWR_LOG_CALLBACK
*/
typedef void (*DHWRLogCallback)(const unsigned short* msg);

#endif // __DHWRDEF_H__
